#
# Copyright (c) 2008-2015 Thierry Florac <tflorac AT ulthar.net>
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#

__docformat__ = 'restructuredtext'


# import standard library

# import interfaces
from pyams_content_es.interfaces import IDocumentIndexInfo
from pyams_workflow.interfaces import IWorkflowState, IWorkflowPublicationSupport, IWorkflowInfo, \
    IWorkflowPublicationInfo
from zope.dublincore.interfaces import IZopeDublinCore

# import packages
from pyams_utils.adapter import adapter_config


@adapter_config(name='workflow', context=IWorkflowPublicationSupport, provides=IDocumentIndexInfo)
def WorkflowManagedContentIndexInfo(content):
    """Workflow managed content index info"""
    dc_info = IZopeDublinCore(content)
    workflow_state = IWorkflowState(content)
    workflow_info = IWorkflowPublicationInfo(content)
    return {'workflow': {'name': IWorkflowInfo(content).name,
                         'status': workflow_state.state,
                         'date': workflow_state.state_date,
                         'created_date': dc_info.created,
                         'modified_date': dc_info.modified,
                         'publication_date': workflow_info.publication_date,
                         'effective_date': workflow_info.publication_effective_date,
                         'push_end_date': workflow_info.push_end_date,
                         'expiration_date': workflow_info.publication_expiration_date,
                         'first_publication_date': workflow_info.first_publication_date}}
